Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/JobData.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/JobData.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/JobData.cs	(revision 4649)
@@ -28,5 +28,5 @@
   [DataContract]
   [Serializable]
-  public class JobData : HiveItem {
+  public class JobData : HiveItemBase {
     [DataMember]
     public Guid JobId { get; set; }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/JobState.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/JobState.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/JobState.cs	(revision 4649)
@@ -23,8 +23,8 @@
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
   public enum JobState {
-    /// <summary>
-    /// Job is actively calculated on a Slave
+        /// <summary>
+    /// A job is offline as long as he is not yet submitted to the hive
     /// </summary>
-    Calculating,
+    Offline,
 
     /// <summary>
@@ -33,4 +33,14 @@
     Waiting,
 
+        /// <summary>
+    /// The job is paused and waits on the server to be sent back to a Slave when all of its child jobs are Finished.
+    /// </summary>
+    WaitingForChildJobs,
+
+    /// <summary>
+    /// Job is actively calculated on a Slave
+    /// </summary>
+    Calculating,
+    
     /// <summary>
     /// Job as finished and is ready to be collected by the Client
@@ -46,10 +56,5 @@
     /// Job as been aborted due to an error. Results are ready to be collected
     /// </summary>
-    Failed,
-
-    /// <summary>
-    /// The job is paused and waits on the server to be sent back to a Slave when all of its child jobs are Finished.
-    /// </summary>
-    WaitForChildJobs
+    Failed
   };
 
@@ -67,5 +72,5 @@
     public static bool IsWaiting(this JobState jobState) {
       return jobState == JobState.Waiting ||
-        jobState == JobState.WaitForChildJobs;
+        jobState == JobState.WaitingForChildJobs;
     }
 
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/LightweightJob.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/LightweightJob.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/LightweightJob.cs	(revision 4649)
@@ -29,9 +29,9 @@
   public class LightweightJob : HiveItem {
     [DataMember]
-    public Guid SlaveId { get; set; }
+    public Guid? SlaveId { get; set; }
     [DataMember]
-    public JobState State { get; set; }
+    public JobState JobState { get; set; }
     [DataMember]
-    public TimeSpan ExecutionTime { get; set; }
+    public TimeSpan? ExecutionTime { get; set; }
     [DataMember]
     public String Exception { get; set; }
@@ -45,9 +45,11 @@
     public Guid? ParentJobId { get; set; }
 
-    public LightweightJob() { }
+    public LightweightJob() {
+      JobState = DataTransfer.JobState.Offline;
+    }
 
     public LightweightJob(Job job) {
       this.SlaveId = job.SlaveId;
-      this.State = job.State;
+      this.JobState = job.JobState;
       this.ExecutionTime = job.ExecutionTime;
       this.Exception = job.Exception;
@@ -61,5 +63,5 @@
       var clone = (LightweightJob)base.Clone(cloner);
       clone.SlaveId = this.SlaveId;
-      clone.State = this.State;
+      clone.JobState = this.JobState;
       clone.ExecutionTime = this.ExecutionTime;
       clone.Exception = this.Exception;
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/Slave.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/Slave.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/Slave.cs	(revision 4649)
@@ -33,5 +33,5 @@
     public int? FreeCores { get; set; }
     [DataMember]
-    public int? CpuSpeedPerCore { get; set; }
+    public int? CpuSpeed { get; set; }
     [DataMember]
     public int? Memory { get; set; }
@@ -39,14 +39,18 @@
     public int? FreeMemory { get; set; }
     [DataMember]
-    public SlaveState State { get; set; }
+    public SlaveState SlaveState { get; set; }
     [DataMember]
-    public CalendarState CalendarSyncStatus { get; set; }
+    public CalendarState CalendarSyncState { get; set; }
     [DataMember]
-    public Guid SlaveConfigId { get; set; }
+    public Guid? SlaveConfigId { get; set; }
     [DataMember]
     public bool IsAllowedToCalculate { get; set; }
 
+    public Slave() {
+      SlaveState = DataTransfer.SlaveState.Idle;
+    }
+
     public override string ToString() {
-      return base.ToString() + ", NrOfCores: " + Cores + ", NrOfFreeCores " + FreeCores + ", State: " + State;
+      return base.ToString() + ", NrOfCores: " + Cores + ", NrOfFreeCores " + FreeCores + ", State: " + SlaveState;
     }
 
@@ -55,9 +59,9 @@
       clone.Cores = this.Cores;
       clone.FreeCores = this.FreeCores;
-      clone.CpuSpeedPerCore = this.CpuSpeedPerCore;
+      clone.CpuSpeed = this.CpuSpeed;
       clone.Memory = this.Memory;
       clone.FreeMemory = this.FreeMemory;
-      clone.State = this.State;
-      clone.CalendarSyncStatus = this.CalendarSyncStatus;
+      clone.SlaveState = this.SlaveState;
+      clone.CalendarSyncState = this.CalendarSyncState;
       clone.SlaveConfigId = this.SlaveConfigId;
       clone.IsAllowedToCalculate = this.IsAllowedToCalculate;
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/SlaveGroup.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/SlaveGroup.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/SlaveGroup.cs	(revision 4649)
@@ -30,13 +30,16 @@
   public class SlaveGroup : Resource {
     [DataMember]
-    public List<Guid> ResourcesIds { get; set; }
+    public List<Guid> ChildResourcesIds { get; set; }
+    [DataMember]
+    public List<Guid> ParentResourcesIds { get; set; }
 
     public SlaveGroup() {
-      ResourcesIds = new List<Guid>();
+      ChildResourcesIds = new List<Guid>();
     }
 
     public override IDeepCloneable Clone(Cloner cloner) {
       var clone = (SlaveGroup)base.Clone(cloner);
-      clone.ResourcesIds = new List<Guid>(this.ResourcesIds);
+      clone.ChildResourcesIds = new List<Guid>(this.ChildResourcesIds);
+      clone.ParentResourcesIds = new List<Guid>(this.ParentResourcesIds);
       return clone;
     }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/Disposable.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/Disposable.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/Disposable.cs	(revision 4649)
@@ -21,4 +21,5 @@
 
 using System;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common {
@@ -34,9 +35,9 @@
 
     public void Dispose() {
-      if (OnDisposing != null)
-        OnDisposing(this, new EventArgs());
+      if (Disposing != null)
+        Disposing(this, new EventArgs<T>(obj));
     }
 
-    public event EventHandler OnDisposing;
+    public event EventHandler<EventArgs<T>> Disposing;
   }
 }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/HeuristicLab.Services.Hive.Common-3.3.csproj
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/HeuristicLab.Services.Hive.Common-3.3.csproj	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/HeuristicLab.Services.Hive.Common-3.3.csproj	(revision 4649)
@@ -67,4 +67,5 @@
     <Compile Include="DataTransfer\HiveExperiment.cs" />
     <Compile Include="DataTransfer\HiveItem.cs" />
+    <Compile Include="DataTransfer\HiveItemBase.cs" />
     <Compile Include="DataTransfer\HivePluginData.cs" />
     <Compile Include="DataTransfer\HivePlugin.cs" />
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/ServiceContracts/IHiveService.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/ServiceContracts/IHiveService.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/ServiceContracts/IHiveService.cs	(revision 4649)
@@ -156,4 +156,7 @@
     #region Slave Methods
     [OperationContract]
+    Guid AddSlave(Slave slave);
+
+    [OperationContract]
     Guid AddSlaveGroup(SlaveGroup slaveGroup);
 
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Convert.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Convert.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Convert.cs	(revision 4649)
@@ -24,21 +24,49 @@
 using System.Linq;
 using DT = HeuristicLab.Services.Hive.Common.DataTransfer;
+using System;
 
 namespace HeuristicLab.Services.Hive.DataAccess {
   public static class Convert {
-
-   
     #region Job
     public static DT.Job ToDto(Job source) {
       if (source == null) return null;
-      return new DT.Job { Id = source.JobId };// todo
+      return new DT.Job {
+        Id = source.JobId,
+        CoresNeeded = source.CoresNeeded,
+        DateCalculated = source.DateCalculated,
+        DateCreated = source.DateCreated,
+        DateFinished = source.DateFinished,
+        Exception = source.Exception,
+        ExecutionTime = source.ExecutionTime,
+        MemoryNeeded = source.MemoryNeeded,
+        ParentJobId = source.ParentJobId,
+        Priority = source.Priority,
+        ProjectId = source.ProjectId,
+        SlaveId = source.SlaveId,
+        JobState = source.JobState,
+        UserId = source.UserId
+      };
     }
     public static Job ToEntity(DT.Job source) {
       if (source == null) return null;
-      return new Job { JobId = source.Id };// todo
+      var entity = new Job(); ToEntity(source, entity);
+      return entity;
     }
     public static void ToEntity(DT.Job source, Job target) {
       if ((source != null) && (target != null)) {
-        target.JobId = source.Id;// todo
+        target.JobId = source.Id;
+        target.CoresNeeded = source.CoresNeeded;
+        target.DateCalculated = source.DateCalculated;
+        target.DateCreated = source.DateCreated;
+        target.DateFinished = source.DateFinished;
+        target.Exception = source.Exception;
+        target.ExecutionTime = source.ExecutionTime;
+        target.MemoryNeeded = source.MemoryNeeded;
+        target.ParentJobId = source.ParentJobId;
+        target.Priority = source.Priority;
+        target.ProjectId = source.ProjectId;
+        target.SlaveId = source.SlaveId;
+        target.JobState = source.JobState;
+        target.UserId = source.UserId;
       }
     }
@@ -48,29 +76,31 @@
     public static DT.JobData ToDto(JobData source) {
       if (source == null) return null;
-      return new DT.JobData { JobId = source.JobId };// todo
+      return new DT.JobData { JobId = source.JobId, Data = source.Data.ToArray() };
     }
     public static JobData ToEntity(DT.JobData source) {
       if (source == null) return null;
-      return new JobData { JobId = source.Id };// todo
+      var entity = new JobData(); ToEntity(source, entity);
+      return entity;
     }
     public static void ToEntity(DT.JobData source, JobData target) {
       if ((source != null) && (target != null)) {
-        target.JobId = source.Id;// todo
+        target.JobId = source.JobId; target.Data = new Binary(source.Data);
       }
     }
     #endregion
-    
+
     #region HiveExperiment
     public static DT.HiveExperiment ToDto(HiveExperiment source) {
       if (source == null) return null;
-      return new DT.HiveExperiment { Id = source.HiveExperimentId };// todo
+      return new DT.HiveExperiment { Id = source.HiveExperimentId, Description = source.Description, Name = source.Name, RootJobId = source.RootJobId, UserId = source.UserId };
     }
     public static HiveExperiment ToEntity(DT.HiveExperiment source) {
       if (source == null) return null;
-      return new HiveExperiment { HiveExperimentId = source.Id };// todo
+      var entity = new HiveExperiment(); ToEntity(source, entity);
+      return entity;
     }
     public static void ToEntity(DT.HiveExperiment source, HiveExperiment target) {
       if ((source != null) && (target != null)) {
-        target.HiveExperimentId = source.Id;// todo
+        target.HiveExperimentId = source.Id; target.Description = source.Description; target.Name = source.Name; target.RootJobId = source.RootJobId; target.UserId = source.UserId;
       }
     }
@@ -80,13 +110,14 @@
     public static DT.Slave ToDto(Slave source) {
       if (source == null) return null;
-      return new DT.Slave { Id = source.ResourceId };// todo
+      return new DT.Slave { Id = source.ResourceId, CalendarSyncState = source.CalendarSyncState, Cores = source.Cores, CpuSpeed = source.CpuSpeed, FreeCores = source.FreeCores, FreeMemory = source.FreeMemory, IsAllowedToCalculate = source.IsAllowedToCalculate, Memory = source.Memory, Name = source.Name, SlaveConfigId = source.SlaveConfigId, SlaveState = source.SlaveState };
     }
     public static Slave ToEntity(DT.Slave source) {
       if (source == null) return null;
-      return new Slave { ResourceId = source.Id };// todo
+      var entity = new Slave(); ToEntity(source, entity);
+      return entity;
     }
     public static void ToEntity(DT.Slave source, Slave target) {
       if ((source != null) && (target != null)) {
-        target.ResourceId = source.Id;// todo
+        target.ResourceId = source.Id; target.CalendarSyncState = source.CalendarSyncState; target.Cores = source.Cores; target.CpuSpeed = source.CpuSpeed; target.FreeCores = source.FreeCores; target.FreeMemory = source.FreeMemory; target.IsAllowedToCalculate = source.IsAllowedToCalculate; target.Memory = source.Memory; target.Name = source.Name; target.SlaveConfigId = source.SlaveConfigId; target.SlaveState = source.SlaveState;
       }
     }
@@ -96,13 +127,17 @@
     public static DT.SlaveGroup ToDto(SlaveGroup source) {
       if (source == null) return null;
-      return new DT.SlaveGroup { Id = source.ResourceId };// todo
+      return new DT.SlaveGroup { Id = source.ResourceId, Name = source.Name, ChildResourcesIds = source.SlaveGroup_Resources_Children.Select(x => x.ResourceId).ToList(), ParentResourcesIds = source.SlaveGroup_Resources_Parents.Select(x => x.ResourceId).ToList() };
     }
     public static SlaveGroup ToEntity(DT.SlaveGroup source) {
       if (source == null) return null;
-      return new SlaveGroup { ResourceId = source.Id };// todo
+      var entity = new SlaveGroup(); ToEntity(source, entity);
+      return entity;
     }
     public static void ToEntity(DT.SlaveGroup source, SlaveGroup target) {
       if ((source != null) && (target != null)) {
-        target.ResourceId = source.Id;// todo
+        target.ResourceId = source.Id;
+        target.Name = source.Name; 
+        //target.SlaveGroup_Resources_Children = // TODO: see how working with groups will work, then decide how to handle enumerations in here
+        //target.SlaveGroup_Resources_Parents = 
       }
     }
@@ -112,13 +147,14 @@
     public static DT.Resource ToDto(Resource source) {
       if (source == null) return null;
-      return new DT.Resource { Id = source.ResourceId };// todo
+      return new DT.Resource { Id = source.ResourceId, Name = source.Name };
     }
     public static Resource ToEntity(DT.Resource source) {
       if (source == null) return null;
-      return new Resource { ResourceId = source.Id };// todo
+      var entity = new Resource(); ToEntity(source, entity);
+      return entity;
     }
     public static void ToEntity(DT.Resource source, Resource target) {
       if ((source != null) && (target != null)) {
-        target.ResourceId = source.Id;// todo
+        target.ResourceId = source.Id; target.Name = source.Name;
       }
     }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HeuristicLab.Services.Hive.DataAccess-3.3.csproj
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HeuristicLab.Services.Hive.DataAccess-3.3.csproj	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HeuristicLab.Services.Hive.DataAccess-3.3.csproj	(revision 4649)
@@ -61,5 +61,4 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="ContextFactory.cs" />
     <Compile Include="Convert.cs" />
     <Compile Include="HeuristicLabServicesHiveDataAccessPlugin.cs" />
@@ -82,4 +81,5 @@
     </Compile>
     <Compile Include="Tools\CreateHiveDatabaseApplication.cs" />
+    <Compile Include="TransactionManager.cs" />
   </ItemGroup>
   <ItemGroup>
